using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_HotelPuntoVenta._1_Datos
{
    public class HPV_PLVFotos_Datos
    {
        #region Obtener
        private dynamic g_dnm_Modelo_Obtener = null;

        public dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                         " SELECT " +
                             nameof(HPV_PLVFotos) + "." + nameof(HPV_PLVFotos.id) + "," +
                             nameof(HPV_PLVFotos) + "." + nameof(HPV_PLVFotos.idPLV) + "," +
                             nameof(HPV_PLVFotos) + "." + nameof(HPV_PLVFotos.foto) + "," +
                             nameof(HPV_PLVFotos) + "." + nameof(HPV_PLVFotos.fechaBorrado) +
                        " FROM " + nameof(HPV_PLVFotos) +
                        " WHERE  " + nameof(HPV_PLVFotos) + "." + nameof(HPV_PLVFotos.idPLV) + "=@idPLV ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idPLV",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<HPV_PLVFotos>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_PLVFotos_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return g_dnm_Modelo_Obtener;
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private HPV_PLVFotos g_mdl_HPV_PLVFotos = null;
        public HPV_PLVFotos Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(HPV_PLVFotos) + "." + nameof(HPV_PLVFotos.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_PLVFotos_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_HPV_PLVFotos;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                               object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_mdl_HPV_PLVFotos = obj_Exferia_Entities.Database.SqlQuery<HPV_PLVFotos>(_str_SQL, _arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_PLVFotos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();

            }
        }
        #endregion

        #region Modelo Listado
        private List<HPV_PLVFotos> g_lst_HPV_PLVFotos = null;

        public List<HPV_PLVFotos> Obtener_ModeloListadoPor_IdPLV(long _lng_idPLV)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(HPV_PLVFotos) + "." + nameof(HPV_PLVFotos.idPLV) + "=@idPLV";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idPLV",  _lng_idPLV)
                };

                Ejecutar_Consulta_Modelo_Listado(str_SQL, arr_Parametros);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_PLVFotos_Datos) + "/" + nameof(Obtener_ModeloListadoPor_IdPLV), true);
            }

            return g_lst_HPV_PLVFotos;
        }

        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                    object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_HPV_PLVFotos = obj_Exferia_Entities.Database.SqlQuery<HPV_PLVFotos>(_str_SQL, _arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_PLVFotos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                       nameof(HPV_PLVFotos.id) + "," +
                       nameof(HPV_PLVFotos.idPLV) + "," +
                       nameof(HPV_PLVFotos.foto) + "," +
                       nameof(HPV_PLVFotos.fechaBorrado) +
                " FROM " + nameof(HPV_PLVFotos);
        }
        #endregion

        #region Grabar
        public INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            // Se utiliza la transaccion por la llamada al procedimiento de almacenado
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                HPV_PLVFotos mdl_HPV_PLVFotos_AGrabar = (HPV_PLVFotos)_mdl_obj;
                HPV_PLVFotos mdl_HPV_PLVFotos_DatosViejos = new HPV_PLVFotos();

                // Ver si existe ######################################################################
                HPV_PLVFotos mdl_HPV_PLVFotos_Final = Obtener_Modelo_Por_Id(mdl_HPV_PLVFotos_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_HPV_PLVFotos_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_HPV_PLVFotos_Final, mdl_HPV_PLVFotos_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_HPV_PLVFotos_AGrabar, mdl_HPV_PLVFotos_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(HPV_PLVFotos) +
                                            " SET " +
                                                 nameof(HPV_PLVFotos.idPLV) + "=@idPLV," +
                                                 nameof(HPV_PLVFotos.foto) + "=@foto," +
                                                 nameof(HPV_PLVFotos.fechaBorrado) + "=@fechaBorrado" +
                                            " WHERE " +
                                                nameof(HPV_PLVFotos.id) + "=@id";




                    //Parametros
                    SqlParameter obj_SqlParameter_imagen = new SqlParameter("@foto", SqlDbType.Binary);
                    if (mdl_HPV_PLVFotos_Final.foto != null)
                    { obj_SqlParameter_imagen.Value = mdl_HPV_PLVFotos_Final.foto; }
                    else
                    { obj_SqlParameter_imagen.Value = DBNull.Value; }

                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@idPLV",  mdl_HPV_PLVFotos_Final.idPLV),
                        obj_SqlParameter_imagen,
                        mdl_HPV_PLVFotos_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_HPV_PLVFotos_Final.fechaBorrado)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id",  mdl_HPV_PLVFotos_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_HPV_PLVFotos_Final.id;
                }
                else
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_HPV_PLVFotos_AGrabar, mdl_HPV_PLVFotos_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(HPV_PLVFotos) +
                                                " (" +
                                                        nameof(HPV_PLVFotos.idPLV) + "," +
                                                        nameof(HPV_PLVFotos.foto) + "," +
                                                        nameof(HPV_PLVFotos.fechaBorrado) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(HPV_PLVFotos.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@idPLV," +
                                                    "@foto," +
                                                    "@fechaBorrado" +
                                                " ) ";
                    //Parametros
                    SqlParameter obj_SqlParameter_imagen = new SqlParameter("@foto", SqlDbType.Binary);
                    if (mdl_HPV_PLVFotos_Final.foto != null)
                    { obj_SqlParameter_imagen.Value = mdl_HPV_PLVFotos_Final.foto; }
                    else
                    { obj_SqlParameter_imagen.Value = DBNull.Value; }

                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idPLV",  mdl_HPV_PLVFotos_Final.idPLV),
                        obj_SqlParameter_imagen,
                        mdl_HPV_PLVFotos_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_HPV_PLVFotos_Final.fechaBorrado)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(HPV_PLVFotos), mdl_HPV_PLVFotos_DatosViejos, mdl_HPV_PLVFotos_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_PLVFotos_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                HPV_PLVFotos mdl_HPV_PLVFotos_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_HPV_PLVFotos_Final != null)
                {
                    #region Delete
                    string str_SQL_Delete = " DELETE FROM  " + nameof(HPV_PLVFotos) +
                                            " WHERE " +
                                                nameof(HPV_PLVFotos.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Delete = new object[]
                    {
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Delete
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                    //Devolver tambien el objeto
                    mdl_ValorDevuelto_Modelo.Id = mdl_HPV_PLVFotos_Final.id;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_PLVFotos_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
